package com.link.base.functiontime.service;

import com.link.base.functiontime.model.FunctionTime;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.List;
import javax.annotation.Resource;
import org.springframework.jdbc.core.BatchPreparedStatementSetter;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

@Service
public class FunctionTimeServiceImpl implements FunctionTimeService {
   @Resource
   private JdbcTemplate jdbcTemplate;

   public void insert(final List<FunctionTime> entity) throws Exception {
      StringBuilder sql = new StringBuilder();
      sql.append("insert into lnk_function_time(FUNCTION_CODE, FUNCTION_NAME, START_TIME, END_TIME, FUNCTION_TIME) values(?,?,?,?,?)");
      this.jdbcTemplate.batchUpdate(sql.toString(), new BatchPreparedStatementSetter() {
         public void setValues(PreparedStatement ps, int i) throws SQLException {
            FunctionTime functionTime = (FunctionTime)entity.get(i);
            ps.setString(1, functionTime.getFunctionCode());
            ps.setString(2, functionTime.getFunctionName());
            ps.setString(3, functionTime.getStartTime());
            ps.setString(4, functionTime.getEndTime());
            ps.setString(5, String.valueOf(functionTime.getFunctionTime()));
         }

         public int getBatchSize() {
            return entity.size();
         }
      });
   }
}
